using System;
using System.Data;
using bizFacade;
using MesServerWork;
//using SystemFramework;

namespace MesServerFunctions
{
    partial class FunctionMES
    {
        object lockBarcodeEngineTypeGetOver = new object();


        /// <summary>
        /// PLC传递机型处理
        /// </summary>
        /// <param name="OpName"></param>
        /// <param name="tagValue"></param>
        private void EngineTypeGetOver_PLC(object e)
        {
            lock(lockBarcodeEngineTypeGetOver) 
            {

                try
                {
                    DoWhatPlc.CustomeEvetnArgs msgEvent = (DoWhatPlc.CustomeEvetnArgs)e;
                    string OpName = Convert.ToString(msgEvent.OpName);
                    int tagValue = Convert.ToInt32(msgEvent.TagValue);
                    if (tagValue == 1)
                    {
                        bool MesRead = false;

                        int EngineTypeID;//机型代码
                        int PartPallet_Code;//托盘编号

                        string EngineType;//机型
                        string EngineID;//工件编号

                        int EngineTypeID_MES;//机型代码
                        string EngineType_MES;//机型
                        string EngineID_MES;//工件编号

                        //上线工位清MES传递机型信号
                        MIS_BASE.Write_EngineTypeGetOver_MES(OpName, false);

                        MIS_BASE.Read_QualityData_Read_CF(OpName, out MesRead);
                        //第一步，判断允许保存和保存完成信号是否全部被清空，若未清空，则通知复位MES&PLC
                        if (MesRead)
                        {
                            //未能清空信号，请求复位
                            SendMessageFun.SendInfomation("AskReset", "1", OpName);
                            return;
                        }
                        string OrderForm;
                        string OrderForm_MES;
                        MIS_BASE.GetEngineTypeFromPLC(OpName, out EngineTypeID, out EngineType, out EngineID, out PartPallet_Code, out OrderForm);
                        MIS_BASE.GetEngineTypeFromPLC_MES(OpName, out EngineTypeID_MES, out EngineType_MES, out EngineID_MES, out OrderForm_MES);
                        
                        //判断PLC机型与MES机型是否一致
                        if (EngineTypeID_MES == EngineTypeID & EngineID_MES == EngineID & EngineType_MES == EngineType)
                        {
                            // 如果机型改变的话 提示机型发生变化
                            DataTable dt = BaseDataSystemMES.EngineTypeChange(OpName, EngineType);
                            if (dt.Rows.Count > 0)
                            {
                                string mesValue = Newtonsoft.Json.JsonConvert.SerializeObject(dt);//<DoWhatPlc.CustomeEvetnArgs>(recData);
                                string message = "MES|MaterialList_Dif_Resources|" + OpName + "|" + mesValue;
                                SendMessage.AsyncSendMessage(message);
                            }
                            //写入到数据库的[北汽福田工位状态监控MOBY]表中
                            BaseDataSystemMES.OpName_MIS_MOBY_Insert(OpName, MobyTagType.EngineTypeID, EngineTypeID.ToString());
                            BaseDataSystemMES.OpName_MIS_MOBY_Insert(OpName, MobyTagType.EngineType, EngineType);
                            BaseDataSystemMES.OpName_MIS_MOBY_Insert(OpName, MobyTagType.EngineID, EngineID);
                            BaseDataSystemMES.OpName_MIS_MOBY_Insert(OpName, MobyTagType.OrderForm, OrderForm);
                            BaseDataSystemMES.OpName_MIS_MOBY_Insert(OpName, MobyTagType.PartPallet_Code, PartPallet_Code.ToString());
                      
                            EngineTypeGetOver_PLC_Work(OpName, EngineTypeID, EngineType, EngineID, PartPallet_Code, OrderForm);
                            return;
                        }
                        else
                        {
                            SendMessage.AsyncSendMessage_Notice(OpName, "码块RFID机型与MES机型不匹配！");
                        }

                    }
                }
                catch (Exception err)
                {
                    ////ApplicationLog.WriteLog(err, "Function08:EngineTypeGetOver_PLC");
                }
            }
           
        }

        

    }
}
